# Coq-PR3 #
A machine learning suite for Coq that allows Coq objects to be clustered, tactics to be analysed and a combination of the two.

# Prerequisites #
* Coq
* Emacs (and ProofGeneral)
* Java

# Installation #
1. Please download the file coqpr3.zip that can be located at the Downloads page (see left hand sidebar).

2. If you have previous installations of SEPIA or ML4PG it may be easier to remove these from your emacs configuration file. Everything required to run both tools is available within this repository.

3. Download coqpr3.zip and unzip to a location of your choice.

4. Inside the extracted directory is a file called coqpr3.el. This contains all of the necessary code to configure and run CoqPR3. In order to make emacs aware of CoqPR3 the following line needs adding to your emacs configuration file:

```
#!emacs lisp
(load-file "/path/to/coqpr3.el")

```
where /path/to/coqpr3.el refers to the location where coqpr3.el now resides.

This should complete the installation process. When Emacs is opened pointing to a Coq theory file, ProofGeneral should load, followed by ML4PG and SEPIA. If everything is installed properly, there should be menus for ML4PG, SEPIA and Coq-PR3.


# Usage #
CoqPR3 contains a suite of tools to perform various functions during proof development.

## Proof Attempts with CoqPR3 ##
The main functionality of this tool is to combine Coq object clustering with tactic analysis. In order to try and prove things automatically the following steps must be obeyed:

1. Firstly, extract the data from any existing theories (if you haven't already). To do this, open the desired theory in ProofGeneral, go to the CoqPR3 menu and select **Step 0: Extract and save data from theory**. This will automatically invoke ML4PG to extract features and hypothesis information that is used later on. When the process is done it will ask you where you wish to save the information. Press enter to accept the default location.

2. Once you have extracted the data from any theories you wish to use, open up the theory containing the proof you want to try and derive. Position the cursor at the last Qed command before the lemma. Go to the CoqPR3 menu and select **Step 1: Extract info upto lemma**. 

3. Go the the ML4PG menu and select **Show cluster libraries**. Then select the theories that were extracted earlier, shown in the **Available libraries for clustering** menu.

4. Go to the CoqPR3 menu and select **Step 3: Generate clusters for selected libraries**.

n. Position the cursor underneath the lemma you want to prove automatically. Then go to the CoqPR3 menu and select **Step 4 Invoke model inference**. This then calls SEPIA and provides all of the information extracted earlier. Hopefully, in the *sepia-output* buffer, there will be some green text showing the proof steps to copy into the proof script.

# Contact #
Coq-PR3 is maintained by Thomas Gransden. Please use the issue tracker to log issues. Please send any other feedback or queries to thomasgransden@gmail.com